/*
    PIP - Platform Independent Primitives
    PIIODevice that pass write to read
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "pitransparentdevice.h"


//! \class PITransparentDevice pitransparentdevice.h
//! \details
//! \~english
//! This class pass all data from \a write() function to \a read().
//! %PITransparentDevice contains internal queue and works in
//! packets mode. If you write 3 different  packets into this device,
//! read will return this 3 packets.
//!
//! \~russian
//! Этот класс транслирует все данные с метода \a write() на метод
//! \a read(). %PITransparentDevice содержит внутреннюю очередь и работает
//! в пакетном режиме. Если запишется 3 различных пакета в устройство,
//! то чтение вернет по очереди эти 3 пакета.
//!


REGISTER_DEVICE(PITransparentDevice)


PITransparentDevice::PITransparentDevice() {}


PITransparentDevice::~PITransparentDevice() {
	stop();
	close();
}


ssize_t PITransparentDevice::bytesAvailable() const {
	ssize_t ret = 0;
	que_mutex.lock();
	if (que.isNotEmpty()) ret = que.back().size();
	que_mutex.unlock();
	return ret;
}


ssize_t PITransparentDevice::readDevice(void * read_to, ssize_t max_size) {
	if (!canRead()) return -1;
	que_mutex.lock();
	if (que.isEmpty()) {
		que_mutex.unlock();
		return 0;
	}
	PIByteArray ba = que.dequeue();
	que_mutex.unlock();
	ssize_t ret = piMini(max_size, ba.size_s());
	memcpy(read_to, ba.data(), ret);
	return ret;
}


ssize_t PITransparentDevice::writeDevice(const void * data, ssize_t max_size) {
	if (!canWrite()) return -1;
	que_mutex.lock();
	que.enqueue(PIByteArray(data, max_size));
	que_mutex.unlock();
	return max_size;
}


bool PITransparentDevice::openDevice() {
	return true;
}


bool PITransparentDevice::closeDevice() {
	que_mutex.lock();
	que.clear();
	que_mutex.unlock();
	return true;
}
